.data
msg: .asciiz "Inserisci intero: "

.text
.globl main

main:
	addi $sp, $sp, -4
	sw $ra, 0($sp)

	# Stampa messaggio
	la $a0, msg        # carica indirizzo stringa
	addi $v0, $0, 4    # carica codice print_string
	syscall

	# Input i
	addi $v0, $0, 5   # carica codice read_integer
	syscall           # legge i

	add $a0, $v0, $0  # $a0 = i
	jal procF         # f(i)

	# Stampa risultato
	add $a0, $v0, $0  # $a0 = f(i)
	addi $v0, $0, 1   # carica codice print_integer
	syscall

	lw $ra, 0($sp)
	addi $sp, $sp, 4

# $a0 = i
procF:
	slti $t0, $a0, 2      # $t0 = (i<2)
	beq $t0, $zero, fRic  # if (i >= 2) goto fRic
	addi $v0, $zero, 1    # return 1
	jr $ra                
fRic:
	addi $sp, $sp, -12   # alloca spazio sullo stack
	sw $ra, 0($sp)       # push $ra
	sw $s0, 4($sp)       # push $s0
	sw $s1, 8($sp)       # push $s1

	add $s0, $zero, $a0  # $s0 = i
	addi $a0, $a0, -2    # $a0 = i-2
	jal procF            # f(i-2)
	sll $s1, $v0, 1      # $s1 = 2*f(i-2)
	
	addi $a0, $s0, -1    # $a0 = i-1
	jal procG            # g(i-1)
	sll $t0, $v0, 2      # $t0 = 4*g(i-1)
	add $t0, $v0, $t0    # $t0 += g(i-1)
	
	add $v0, $t0, $s1    # $v0 = 2f(i-2)+5g(i-1)
	add $v0, $v0, $s0    # $v0 += i
	addi $v0, $v0, -3    # $v0 -= 3

	lw $ra, 0($sp)       # pop $ra
	lw $s0, 4($sp)       # pop $s0
	lw $s1, 8($sp)       # pop $s1
	addi $sp, $sp, 12    # ripristina $sp
	jr $ra	

# $a0 = i
procG:
	slti $t0, $a0, 3      # $t0 = (i<3)
	beq $t0, $zero, gRic  # if i>=3 goto gRic
	addi $v0, $zero, 4    # return 4
	jr $ra
gRic:
	addi $sp, $sp, -12   # alloca spazio sullo stack
	sw $ra, 0($sp)       # push $ra
	sw $s0, 4($sp)       # push $s0
	sw $s1, 8($sp)       # push $s1

	add $s0, $a0, $zero  # $s0 = i
	srl $a0, $a0, 1      # $a0 = i/2
	jal procF            # f(i/2)
	add $s1, $zero, $v0  # $s1 = f(i/2)

	addi $a0, $s0, -1    # $a0 = i-1
	jal procG            # g(i-1)

	add $a0, $zero, $v0  # $a0 = g(i-1)
	add $a1, $zero, $s1  # $a1 = f(i/2)
	add $a2, $zero, $s0  # $a2 = i
	jal min3

	lw $ra, 0($sp)       # pop $ra
	lw $s0, 4($sp)       # pop $s0
	lw $s1, 8($sp)       # pop $s1
	addi $sp, $sp, 12    # ripristina $sp
	jr $ra	

# $a0, $a1, $a2 <- x,y,z
# $v0 -> min(x,y,z)
min3:
	slt $t0, $a0, $a1        # $t0 = (x<y)
	beq $t0, $zero, swapXZ   # if x>=y goto swapXZ
	add $a1, $zero, $a2      # $a0 = min(x,y), $a1 = z
	j min2
swapXZ:
	add $a0, $zero, $a2      # $a1 = min(x,y), $a0 = z
min2:
	slt $t0, $a0, $a1        # $t0 = (x'<y')
	beq $t0, $zero, minY     # if x'>=y' goto minY
	add $v0, $zero, $a0      # return x'
	jr $ra
minY:
	add $v0, $zero, $a1     # return y'
	jr $ra
