#include <stdio.h>
#include <stdlib.h>

int *crea_array (int n)
{
	int *array = malloc(n*sizeof(int));
	if (array == NULL) {
		printf("Impossibile allocare memoria.\n");
		exit(2);
	}

	return array;
}

int leggi_dimensione_array ()
{
	int n;
	printf("Inserisci lunghezza array: ");
	if (scanf("%d", &n) != 1 || n < 1) {
		printf("Inserito valore non valido!\n");
		exit(1);
	}

	return n;
}

void inizializza_array (int *a, int n)
{
	int i;
	for (i=0; i<n; i++) {
		a[i] = i;
	}
}

void stampa_array (int *a, int n)
{
	int *ptr;
	for (ptr = a; ptr < a+n; ptr++) {
		printf("%d ", *ptr);
	}
	printf("\n");
}


int main()
{
	int dim = leggi_dimensione_array();
	int *A = crea_array(dim);
	inizializza_array (A, dim);
	stampa_array (A, dim);

	free(A);

	return 0;
}
